Name:		qubes-utils
Version:	4.2.17
Release:	1%{?dist}
Summary:	Common Linux files for Qubes Dom0 and VM
Source0:    %{name}-%{version}.tar.gz

Group:		Qubes
License:	GPL
URL:		http://www.qubes-os.org

Requires:	udev
Requires:	%{name}-libs
Requires:	GraphicsMagick
Requires:	python%{python3_pkgversion}-qubesimgconverter
Requires:	(%{name}-selinux if selinux-policy)
%{?systemd_requires}
BuildRequires:  systemd
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  python3-rpm-macros
# for meminfo-writer
BuildRequires:  xen-devel
BuildRequires:	gcc
BuildRequires:  selinux-policy-devel
%if 0%{?is_opensuse}
# for directory ownership
BuildRequires: xen-tools
%endif

%description
Common Linux files for Qubes Dom0 and VM

%package -n python%{python3_pkgversion}-qubesimgconverter
Summary:    Python package qubesimgconverter
Requires:   python%{python3_pkgversion}
Requires:   python%{python3_pkgversion}-cairo
%if 0%{?is_opensuse}
Requires:   python%{python3_pkgversion}-Pillow
%else
Requires:   python%{python3_pkgversion}-pillow
%endif
Requires:   python%{python3_pkgversion}-numpy

%description -n python%{python3_pkgversion}-qubesimgconverter
Python package qubesimgconverter

%package devel
Summary:	Development headers for qubes-utils
Release:	1%{?dist}
Requires:	%{name}-libs

%description devel
Development header and files for qubes-utils

%package libs
Summary: Qubes utils libraries
Release:	1%{?dist}
BuildRequires:	pkgconfig(icu-uc)
BuildRequires:	python3

%description libs
Libraries for qubes-utils

%package selinux

BuildRequires: selinux-policy
%{?selinux_requires}

Summary: SELinux policy for meminfo-writer
License: GPLv2+

%description selinux
SELinux policy for meminfo-writer.  You need this package to run meminfo-writer
on a system where SELinux is in enforcing mode.

%post selinux
%selinux_modules_install %{_datadir}/selinux/packages/qubes-meminfo-writer.pp || :

%postun selinux
if [ "$1" -eq 0 ]; then
    %selinux_modules_uninstall %{_datadir}/selinux/packages/qubes-meminfo-writer.pp
fi || :

%posttrans selinux
%selinux_relabel_post
exit 0

%files selinux
%{_datadir}/selinux/packages/qubes-meminfo-writer.pp
%{_datadir}/selinux/devel/include/contrib/ipp-qubes-meminfo-writer.if

%prep
%setup -q

%build
make all selinux BACKEND_VMM=xen PYTHON=%{__python3} NO_REBUILD_TABLE=1

%check
make -C qrexec-lib check NO_REBUILD_TABLE=1
%if 0%{?fedora} == 38
make -C qrexec-lib check-table-up-to-date NO_REBUILD_TABLE=1
%endif

%install
make install install-selinux DESTDIR=%{buildroot} PYTHON=%{__python3} NO_REBUILD_TABLE=1

%post
# dom0
%systemd_post qubes-meminfo-writer-dom0.service
# VM
%systemd_post qubes-meminfo-writer.service

%preun
%systemd_preun qubes-meminfo-writer-dom0.service
%systemd_preun qubes-meminfo-writer.service

%postun
%systemd_postun_with_restart qubes-meminfo-writer-dom0.service
%systemd_postun_with_restart qubes-meminfo-writer.service

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%_udevrulesdir/*-qubes-*.rules
%_tmpfilesdir/xen-devices-qubes.conf
%dir %{_prefix}/lib/qubes
%{_prefix}/lib/qubes/udev-*
%{_sbindir}/meminfo-writer
%{_unitdir}/qubes-meminfo-writer.service
%{_unitdir}/qubes-meminfo-writer-dom0.service
%dir %_includedir/qubes
/etc/xen/scripts/qubes-block

%files -n python%{python3_pkgversion}-qubesimgconverter
%dir %{python3_sitelib}/qubesimgconverter
%{python3_sitelib}/qubesimgconverter/__init__.py
%{python3_sitelib}/qubesimgconverter/imggen.py
%{python3_sitelib}/qubesimgconverter/test.py
%{python3_sitelib}/qubesimgconverter/test_integ.py
%{python3_sitelib}/qubesimgconverter-%{version}-py?.[0-9]*.egg-info
%{python3_sitelib}/qubesimgconverter/__pycache__

%files libs
%{_libdir}/libqubes-rpc-filecopy.so.2
%{_libdir}/libqubes-pure.so.0

%files devel
%defattr(-,root,root,-)
%_includedir/libqubes-rpc-filecopy.h
%dir %_includedir/qubes
%_includedir/qubes/pure.h
%{_libdir}/libqubes-rpc-filecopy.so
%{_libdir}/libqubes-pure.so

%changelog
* Sat Jun 22 2024 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-linux-utils

* Sat Jun 22 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e6a80c7
- version 4.2.17

* Sat Jun 22 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 59664fe
- Do not redefine compiler flags that are up to build env to define

* Sat Jun 22 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5025d32
- debian: bump required versions for libs

* Sat Jun 22 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bc02ee8
- ci: update tags

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 1bc5d7c
- Don't allow trailing slashes in paths being unpacked

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 641ba4d
- Allow disabling symbolic link checking

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 9912ad6
- Add flag to allow non-canonical symbolic links

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 68b54f6
- Use for loop instead of do-while

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 030ae67
- Improve symlink tests

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - acfa2b6
- Allow disabling character set filtering

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - ae8c2ce
- Better error message for forbidden symbolic links

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - be7940c
- Avoid redundantly validating symbolic link names

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 8db9b67
- Fix -Wmissing-declarations and -Wmissing-prototypes warnings

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - f1e5736
- Avoid casting away const when not needed

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - edf98b8
- Document the pretty-printer in the code generator

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 6e7c758
- Move path validation tests before charset tests

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - d3834f3
- Test that symbolic links can end in '/'

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 6040f62
- Allow symlinks ending in ".."

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 7990a9c
- Document algorithm used to sanitize paths

* Sat Jun 22 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 0221a90
- Math and currency symbols are safe for display

* Sat Jun 22 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 654f4c2
- Switch to sequoia for codecov signature check

* Sat Jun 22 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 52d6b50
- Fix imgconverter tests

* Sat Jun 22 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8950fe7
- ci: collect test coverage from qrexec-lib too

* Mon Dec 04 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5df5616
- version 4.2.15

* Sun Dec 03 2023 Rusty Bird <rustybird@net-c.com> - 13a0ede
- qrexec-lib/pack: sanitize straight quotes in remote filenames

* Sat Dec 02 2023 Rusty Bird <rustybird@net-c.com> - 71f5b04
- qrexec-lib/pack: don't use curly quotes in error messages

* Mon Nov 13 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b1e335a
- Avoid writing junk into Xenstore

* Sun Nov 05 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 24cdce9
- rpm: adjust dependencies for openSUSE

* Sat Nov 04 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ad0b68b
- genfs: fix build/link flags

* Sat Nov 04 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bc62e92
- rpm: fix missing directory ownership

* Wed Sep 27 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 96698e2
- version 4.2.14

* Wed Sep 27 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - f89a3b8
- Block Zalgo text

* Sun Sep 24 2023 Rusty Bird <rustybird@net-c.com> - 3ee5516
- qrexec-lib/unpack: fail on EOF before end of transfer marker

* Sun Sep 17 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 3925e82
- Expose code point allowlist checking API

* Sun Sep 10 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6c4902e
- version 4.2.13

* Sun Aug 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6fe6fac
- version 4.2.12

* Wed Aug 16 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 711e416
- Drop unmaintained asynctest library

* Mon Aug 14 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6f4f1ab
- Make qubes_pure_string_safe_for_display() usable

* Fri Aug 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 26c3e30
- debian: split libqubes-pure into separate package

* Fri Aug 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 65bc3f4
- Test rejection of codepoints past 0x10FFFFF

* Thu Aug 10 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 2cd3547
- Stricter symbolic link checks

* Thu Aug 10 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b1c9bb6
- Link against just-built libqubes-pure

* Tue Jul 04 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d4c9805
- version 4.2.11

* Sat Jul 01 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 80efd31
- libqubes-pure: Add function for qube name validation

* Fri Jun 30 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - dbc5de5
- Add missing entries to .gitignore

* Fri Jun 30 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 91b2cf3
- version 4.2.10

* Mon Jun 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9efc9e3
- debian: reduce initramfs size

* Mon May 29 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 73a6d3a
- Update the character allowlist

* Mon May 29 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6c0246c
- version 4.2.9

* Tue May 23 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - d7b5bf9
- Allow meminfo-writer to create and use AF_UNIX stream sockets

